#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                 ind - Profitunity AO Signals.mq4 |
//| Fractals                                                         |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Copyright  2003, Alexey Zerg"
#property link      " http://profitunity.com.ru"

#property indicator_chart_window
#property indicator_color1 Blue
#property indicator_buffers 2
#property indicator_color2 Red

extern bool Sig1=true,Sig2=true,Sig3=true;
extern int    ArrowDis=1;
//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double nAccountedBars = 300;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID);
   SetIndexBuffer(1, ExtHistoBuffer2);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int CurrentBar = 0;
double price = 0;
double n = 0;
double k = 0;

/*[[
    Name := Profitunity AO Signals
	Author := Copyright  2003, Alexey Zerg
	Link := http://profitunity.com.ru
    Notes := Fractals
    Separate Window := No
    First Color := Blue
    First Draw Type := Symbol
    First Symbol := 110
    Use Second Data := Yes
    Second Color := Red
    Second Draw Type := Symbol
    Second Symbol := 110
]]*/



SetLoopCount(0);

k = (((High[1]-Low[1])+(High[2]-Low[2])+(High[3]-Low[3])+(High[4]-Low[4])+(High[5]-Low[5]))/5)/3;

for(CurrentBar =0;CurrentBar <=nAccountedBars ;CurrentBar ++){ 

//  
if( iAO(NULL, 0, CurrentBar) >= 0 && iAO(NULL, 0, CurrentBar+1) < 0 && Sig1==true) 
{
SetIndexValue(CurrentBar, Low[CurrentBar]-k-ArrowDis*Point);
}




if( iAO(NULL, 0, CurrentBar) <= 0 && iAO(NULL, 0, CurrentBar+1) > 0 && Sig1==true) 
{
SetIndexValue2(CurrentBar, High[CurrentBar]+k+ArrowDis*Point);
}


if( iAO(NULL, 0, CurrentBar) < iAO(NULL, 0, CurrentBar+1) && iAO(NULL, 0, CurrentBar+1) < iAO(NULL, 0, CurrentBar+2) && iAO(NULL, 0, CurrentBar+2) < iAO(NULL, 0, CurrentBar+3) && iAO(NULL, 0, CurrentBar+3) > iAO(NULL, 0, CurrentBar+4) )
{
 if( iAO(NULL, 0, CurrentBar) > 0  && Sig2==true)  
 {
  SetIndexValue2(CurrentBar, High[CurrentBar]+k);
 }
  else 
 {
  n=1;
  while( iAO(NULL, 0, CurrentBar+n) < 0) 
  {
  if( iAO(NULL, 0, CurrentBar+n) > iAO(NULL, 0, CurrentBar+1+n) && iAO(NULL, 0, CurrentBar+1+n) < iAO(NULL, 0, CurrentBar+2+n) && iAO(NULL, 0, CurrentBar+n) < iAO(NULL, 0, CurrentBar)  && Sig3==true) 
  {
   SetIndexValue(CurrentBar, Low[CurrentBar]-k-ArrowDis*Point);
   break;
  }
  n = n+1;
  }
 }
}

if( iAO(NULL, 0, CurrentBar) > iAO(NULL, 0, CurrentBar+1) && iAO(NULL, 0, CurrentBar+1) > iAO(NULL, 0, CurrentBar+2) && iAO(NULL, 0, CurrentBar+2) > iAO(NULL, 0, CurrentBar+3) && iAO(NULL, 0, CurrentBar+3) < iAO(NULL, 0, CurrentBar+4) ) 
  {
  if( iAO(NULL, 0, CurrentBar) < 0  && Sig2==true) 
 {
  SetIndexValue(CurrentBar, Low[CurrentBar]-k);
 }
  else 
 {
  n=1;
  while( iAO(NULL, 0, CurrentBar+n) > 0
  ) {
  if( iAO(NULL, 0, CurrentBar+n) < iAO(NULL, 0, CurrentBar+1+n) && iAO(NULL, 0, CurrentBar+1+n) > iAO(NULL, 0, CurrentBar+2+n) && iAO(NULL, 0, CurrentBar+n) > iAO(NULL, 0, CurrentBar)  && Sig3==true) 
  {
   SetIndexValue2(CurrentBar, High[CurrentBar]+k+ArrowDis*Point);
   break;
  }
  n = n+1;
  }
 }
}

}   return(0);
}
